(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("lib-bb-portal-rest", [], factory);
	else if(typeof exports === 'object')
		exports["lib-bb-portal-rest"] = factory();
	else
		root["lib-bb-portal-rest"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _execute = __webpack_require__(2);
	
	var _execute2 = _interopRequireDefault(_execute);
	
	var _serverMethods = __webpack_require__(5);
	
	var _serverMethods2 = _interopRequireDefault(_serverMethods);
	
	var _chainMethods = __webpack_require__(7);
	
	var _chainMethods2 = _interopRequireDefault(_chainMethods);
	
	var _response = __webpack_require__(8);
	
	var _response2 = _interopRequireDefault(_response);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	/**
	 * @module lib-bb-portal-rest
	 * @description
	 * Provides a cross-platform SDK for Backbase REST APIs
	 *
	 * @example
	 * import bbrest from 'lib-bb-portal-rest';
	 * import ajaxAdapter from 'lib-bb-portal-rest-ajax-adapter';
	 *
	 * const BBRest = bbrest(ajaxAdapter, { port: 8080 });
	 *
	 * BBRest.importPackage().file('item.zip').post()
	 *   .then(xmlString => {
	 *     // do something
	 *   });
	 */
	var getConfig = function getConfig(config) {
	  var defaults5 = {
	    scheme: 'http',
	    host: 'localhost',
	    port: '7777',
	    context: 'portalserver',
	    username: 'developer',
	    password: 'developer',
	    authPath: 'portalserver/j_spring_security_check',
	    orchestrator: 'orchestrator',
	    version: '5'
	  };
	
	  var defaults6 = {
	    scheme: 'http',
	    host: 'cx.local.backbase.io',
	    port: '8080',
	    context: 'gateway/api',
	    username: 'admin',
	    password: 'admin',
	    authPath: 'gateway/api/auth/login',
	    orchestrator: 'orchestratoreditorial'
	  };
	
	  var defaults = config.version && config.version.charAt(0) === '6' ? defaults6 : defaults5;
	  return Object.assign({}, defaults, config);
	};
	
	/**
	 * @name default
	 * @type {function}
	 * @description BBRest constructor
	 * @param {Adapter} adapter js module exposing cross platform methods
	 * @param {RestConfig} restConfig Configuration object
	 * @param {?Middleware[]} middleware Array of middleware functions.
	 * @returns {BBRest} BBRest API
	 */
	
	exports.default = function (adapter, restConfig) {
	  var middleware = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
	
	  if (!adapter) {
	    throw new Error('Adapter must be defined!');
	  }
	  var config = getConfig(restConfig);
	  adapter.log('Configuration', config);
	
	  var configuredMiddleware = middleware.map(function (mw) {
	    return mw(adapter, config);
	  });
	
	  var execute = (0, _execute2.default)(adapter, config, configuredMiddleware, _response2.default);
	  return (0, _serverMethods2.default)((0, _chainMethods2.default)(execute));
	};
	
	/**
	 * @typedef Adapter
	 * @type {object}
	 * @description Platform specific adapter module
	 * @property {function} request http request method
	 * @property {function} log log method
	 * @property {function} btoa base64 string convert method
	 * @property {function} DOMParser DOM parser implementation
	 */
	
	/**
	 * @typedef RestConfig
	 * @type {object}
	 * @description Rest API Configuration
	 * @property {string} scheme url scheme
	 * @property {string} host url host
	 * @property {string} port url port
	 * @property {string} context url path prefix
	 * @property {string} username username
	 * @property {string} password password
	 * @property {string} authPath url path for authorization
	 * @property {string} orchestrator path of the orchestrator
	 * @property {string} version portal version
	 */
	
	/**
	 * @typedef RequestObject
	 * @type {object}
	 * @property {string} url relative url path of http request
	 * @property {string} method http method
	 * @property {object} query query hash
	 * @property {object} headers headers hash
	 * @property {string} importFile NodeJS: path of the file to upload, browser: Blob object to upload
	 * @property {string} exportFile file path (NodeJS) or name (browser) to download to
	 * @property {string} formField name of the form field for upload
	 */
	
	/**
	 * @typedef Middleware
	 * @type {function}
	 * @description Middleware functions are used to change http request before it is executed.
	 * @param {Adapter} adapter js module exposing cross platform methods
	 * @param {RestConfig} restConfig Configuration object
	 * @returns {ConfiguredMiddleware} function that runs middleware
	 */
	
	/**
	 * @typedef ConfiguredMiddleware
	 * @type {function}
	 * @description Function that executes middleware.
	 * @param {RequestObject} reqObj Request object
	 * @returns {RequestObject} Request object to execute
	 */

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _deleteAllCache = __webpack_require__(3);
	
	var _deleteAllCache2 = _interopRequireDefault(_deleteAllCache);
	
	var _urlResolver = __webpack_require__(4);
	
	var _urlResolver2 = _interopRequireDefault(_urlResolver);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }
	
	var runMiddleware = function runMiddleware(allMiddleware, adapter, config, reqObj) {
	  return allMiddleware.reduce(function (acc, middleware) {
	    return acc.then(function (reqo) {
	      return middleware(reqo);
	    });
	  }, Promise.resolve(reqObj));
	};
	
	var getRequest = function getRequest(adapter, config, middleware, handleResponse) {
	  return function (reqObj, payload) {
	    return runMiddleware(middleware, adapter, config, reqObj).then(function (mwReqObj) {
	      return adapter.request(mwReqObj, payload).then(function (response) {
	        return handleResponse(adapter, config, mwReqObj, response);
	      });
	    });
	  };
	};
	
	exports.default = function (adapter, config, middleware, response) {
	  var doRequest = getRequest(adapter, config, middleware, response);
	  var getUrl = (0, _urlResolver2.default)(config);
	
	  /**
	   * @inner
	   * @name BBRest#execute
	   * @type {function}
	   * @param {RequestExecuteObject} reqObj
	   * @param {string} xmlString xml formatted according to Backbase xsd
	   * @returns {Promise.<string|CXPError>} response body returned from the portal or error
	   */
	  return function (reqObj, payload) {
	    var requestObj = Object.assign({}, reqObj);
	
	    if (requestObj.path[0] === 'caches' && requestObj.path[1] === 'all') {
	      return (0, _deleteAllCache2.default)(doRequest, getUrl, requestObj);
	    }
	    if (requestObj.path[0] === 'orchestrator') {
	      requestObj.path = [config.orchestrator].concat(_toConsumableArray(reqObj.path.slice(1)));
	    }
	    var uri = requestObj.path.join('/');
	    requestObj.url = getUrl(uri);
	
	    return doRequest(requestObj, payload);
	  };
	};
	
	/**
	 * @inner
	 * @typedef RequestExecuteObject
	 * @type {object}
	 * @property {string} path array of url components
	 * @property {string} method http method
	 * @property {object} query query hash
	 * @property {object} headers headers hash
	 * @property {string} importFile NodeJS: path of the file to upload, browser: Blob object to upload
	 * @property {string} exportFile file path (NodeJS) or name (browser) to download to
	 * @property {string} formField name of the form field for upload
	 */

/***/ }),
/* 3 */
/***/ (function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var cacheNames = ['globalModelCache', 'retrievedWidgetCache', 'widgetChromeStaticCache', 'serverSideClosureCache', 'urlLevelCache', 'contentTemplateCache', 'webCache', 'gModelCache', 'uuidFromExtendedItemNamesCache', 'springAclCacheRegion', 'springAclSidCacheRegion', 'contextNameToItemNameToUuidCache', 'widgetCache', 'uuidToContentReferencesCache', 'itemUuidToReferencingLinkUuidsCache', 'uuidToCacheKeysCache', 'versionBundleCache'];
	
	var deleteCache = function deleteCache(doRequest, getUrl, reqObj) {
	  return function (name) {
	    var path = reqObj.path.concat(name).join('/');
	    var url = getUrl(path);
	    return doRequest(Object.assign({}, reqObj, { url: url }));
	  };
	};
	
	exports.default = function (doRequest, getUrl, reqObj) {
	  var doDelete = deleteCache(doRequest, getUrl, reqObj);
	  return cacheNames.reduce(function (promise, name) {
	    return promise.then(function () {
	      return doDelete(name);
	    }).catch(function (error) {
	      if (error.response.status === 404) return;
	      throw error;
	    });
	  }, Promise.resolve());
	};

/***/ }),
/* 4 */
/***/ (function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	exports.default = function (_ref) {
	  var scheme = _ref.scheme,
	      host = _ref.host,
	      port = _ref.port,
	      context = _ref.context;
	
	  var url = [];
	  if (host) {
	    if (scheme) url.push(scheme + ':/');
	    if (port) url.push(host + ':' + port);else url.push(host);
	  } else {
	    url.push(''); // adds slash for absolute url
	  }
	  if (context) url.push(context);
	  return function (path) {
	    return url.concat(path).join('/');
	  };
	};

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _portalMethods = __webpack_require__(6);
	
	var _portalMethods2 = _interopRequireDefault(_portalMethods);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	exports.default = function (chainMethods) {
	  return {
	    server: function server() {
	      return chainMethods('server', ['portals']);
	    },
	    portal: function portal(portalName) {
	      var path = ['portals', portalName];
	      return Object.assign({}, chainMethods('portal', path), (0, _portalMethods2.default)(chainMethods, portalName));
	    },
	    catalog: function catalog(item) {
	      var path = ['catalog'];
	      if (item) path.push(item);
	      return chainMethods('server', path);
	    },
	    user: function user(userName, showGroups, groupName) {
	      var path = ['users'];
	      if (userName) path.push(userName);
	      if (showGroups) path.push('groups');
	      if (groupName) path.push(groupName);
	      return chainMethods('user', path);
	    },
	    group: function group(groupName, showUsers, userName) {
	      var path = ['groups'];
	      if (groupName) path.push(groupName);
	      if (showUsers) path.push('users');
	      if (userName) path.push(userName);
	      return chainMethods('group', path);
	    },
	    template: function template(templateName) {
	      var path = ['templates'];
	      if (templateName) path.push(templateName);
	      return chainMethods('template', path);
	    },
	    feature: function feature(featureName) {
	      var path = ['features'];
	      if (featureName) path.push(featureName);
	      return chainMethods('feature', path);
	    },
	    audit: function audit(meta) {
	      return chainMethods('audit', [meta ? 'auditmeta' : 'auditevents']);
	    },
	    cache: function cache(type) {
	      var path = ['caches', type];
	      return chainMethods('cache', path);
	    },
	    import: function _import() {
	      var path = ['import', 'portal'];
	      return chainMethods('import', path);
	    },
	    export: function _export(uuid) {
	      if (uuid) {
	        return chainMethods('export', ['orchestrator', 'export', 'files', uuid]);
	      }
	      return chainMethods('export', ['orchestrator', 'export', 'exportrequests']);
	    },
	    importPackage: function importPackage() {
	      var path = ['import', 'package'];
	      return chainMethods('importPackage', path);
	    },
	    exportPackage: function exportPackage(itemName) {
	      var path = ['export', 'package', itemName];
	      return chainMethods('exportPackage', path);
	    },
	    provision: function provision(uuid, download) {
	      var path = ['provisioning', download ? 'item' : 'packages'];
	      if (uuid) path.push(uuid);
	      return chainMethods('provision', path);
	    }
	  };
	};

/***/ }),
/* 6 */
/***/ (function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	exports.default = function (chainMethods, portalName) {
	  return {
	    catalog: function catalog(item) {
	      var path = ['portals', portalName, 'catalog'];
	      if (item) path.push(item);
	      return chainMethods('portal', path);
	    },
	    container: function container(containerName) {
	      var path = ['portals', portalName, 'containers'];
	      if (containerName) path.push(containerName);
	      return chainMethods('container', path);
	    },
	    widget: function widget(widgetName) {
	      var path = ['portals', portalName, 'widgets'];
	      if (widgetName) path.push(widgetName);
	      return chainMethods('widget', path);
	    },
	    page: function page(pageName) {
	      var path = ['portals', portalName, 'pages'];
	      if (pageName) path.push(pageName);
	      return chainMethods('page', path);
	    },
	    link: function link(linkName) {
	      var path = ['portals', portalName, 'links'];
	      if (linkName) path.push(linkName);
	      return chainMethods('link', path);
	    },
	    importPackage: function importPackage() {
	      var path = ['import', 'package', portalName];
	      return chainMethods('importPackage', path);
	    },
	    exportPackage: function exportPackage(itemName) {
	      var path = ['export', 'package', portalName, itemName];
	      return chainMethods('exportPackage', path);
	    },
	    export: function _export() {
	      var path = ['export', 'portal'];
	      return chainMethods('export', path, portalName);
	    }
	  };
	};

/***/ }),
/* 7 */
/***/ (function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var createHttpMethods = function createHttpMethods(reqObj, meta, handler) {
	  return {
	    get: function get() {
	      var decor = {
	        method: 'GET'
	      };
	      var path = reqObj.path.concat();
	      /* methods that use .xml:
	       * portal().xml().get()
	       * portalCatalog('item').get()
	       * container('name').xml().get()
	       * widget('name').xml().get()
	       * page('name').xml().get()
	       * link('name').xml().get() */
	      if (path[0] === 'portals' && path.length === 2) path[1] += '.xml';
	      if (path[2] === 'catalog' && path[3]) path[3] += '.xml';
	      if (path[4] !== 'rights') {
	        if (path[2] === 'pages' && path[3]) path[3] += '.xml';
	        if (path[2] === 'containers' && path[3]) path[3] += '.xml';
	        if (path[2] === 'widgets' && path[3]) path[3] += '.xml';
	        if (path[2] === 'links' && path[3]) path[3] += '.xml';
	      }
	      decor.path = path;
	
	      if (meta.command === 'export' && meta.portalName) {
	        decor.query = Object.assign({}, reqObj.query, { portalName: meta.portalName });
	      }
	      return handler(decor);
	    },
	    post: function post(payload) {
	      var decor = {
	        method: 'POST'
	      };
	      if (meta.command === 'import' && reqObj.importFile) {
	        decor.path = ['orchestrator', 'import', 'upload'];
	      }
	      if (reqObj.importFile) {
	        decor.formField = meta.command === 'import' ? 'file' : 'package';
	      }
	      if (meta.command === 'export' && meta.portalName) {
	        decor.path = ['orchestrator', 'export', 'exportrequests'];
	        return handler(decor, '<exportRequest>\n  <portalExportRequest>\n  <portalName>' + meta.portalName + '</portalName>\n    <includeContent>true</includeContent>\n    <includeGroups>true</includeGroups>\n  </portalExportRequest>\n</exportRequest>');
	      }
	      return handler(decor, payload);
	    },
	    put: function put(payload) {
	      return handler({ method: 'PUT' }, payload);
	    },
	    // fixing inconsistencies in API
	    // server /delete/catalog POST
	    // portal /portals/[portal_name]/delete/catalog POST
	    // link /portals/[portal_name]/delete/links POST
	    delete: function _delete(payload) {
	      var decor = {
	        method: 'DELETE'
	      };
	      if (payload) {
	        decor.method = 'POST';
	        switch (meta.command) {
	          case 'server':
	            decor.path = ['delete', 'catalog'];
	            break;
	          case 'portal':
	            decor.path = reqObj.path.slice(0, 2).concat(['delete', 'catalog']);
	            break;
	          case 'link':
	            decor.path = reqObj.path.slice(0, 2).concat(['delete', 'links']);
	            break;
	          default:
	          // code
	        }
	      }
	      return handler(decor, payload);
	    }
	  };
	};
	
	var otherMethods = function otherMethods(reqObj, handler) {
	  return {
	    rights: function rights() {
	      return handler({ path: reqObj.path.concat(['rights']) });
	    },
	    tags: function tags(tagName, tagType) {
	      if (reqObj.path[0] === 'catalog') {
	        return handler({ path: ['catalogTags'] }); // server catalog tags
	      } else if (reqObj.path[2] === 'catalog' && !reqObj.path[3]) {
	        // portal catalog tags
	        return handler({ path: reqObj.path.slice(0, 2).concat(['catalogTags']) });
	      }
	      var decor = { path: reqObj.path.concat(['tags']) };
	      if (tagName) decor.path.push(tagName);
	      if (tagType) decor.query = Object.assign({}, reqObj.query, { type: tagType });
	      return handler(decor);
	    },
	    query: function query(queryObject) {
	      return handler({ query: Object.assign({}, reqObj.query, queryObject) });
	    },
	    file: function file(_file) {
	      if (reqObj.path[0] === 'import' || reqObj.path[0] === 'provisioning' && reqObj.path[1] === 'packages') {
	        return handler({
	          importFile: _file
	        });
	      }
	      return handler({ exportFile: _file });
	    }
	  };
	};
	
	exports.default = function (executeRequest) {
	  return function (command, path, portalName) {
	    var reqObj = {
	      path: path.concat(),
	      query: {},
	      headers: {}
	    };
	
	    var meta = {
	      command: command,
	      portalName: portalName
	    };
	
	    var httpMethodHandler = function httpMethodHandler(reqPlus, payload) {
	      Object.assign(reqObj, reqPlus);
	      return executeRequest(reqObj, payload);
	    };
	    var httpMethods = createHttpMethods(reqObj, meta, httpMethodHandler);
	
	    var otherHandler = function otherHandler(reqPlus) {
	      Object.assign(reqObj, reqPlus);
	      return httpMethods;
	    };
	    return Object.assign(httpMethods, otherMethods(reqObj, otherHandler));
	  };
	};

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _xx = __webpack_require__(9);
	
	var _xx2 = _interopRequireDefault(_xx);
	
	var _xx3 = __webpack_require__(10);
	
	var _xx4 = _interopRequireDefault(_xx3);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }
	
	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
	
	/**
	 * @typedef CXPError
	 * @type {error}
	 * @property {String} message error message
	 * @property {Response} response http response object
	 * @property {RequestObject} request http request object
	 * @property {RestConfig} restConfig REST API configuration
	 */
	var CXPError = function (_Error) {
	  _inherits(CXPError, _Error);
	
	  function CXPError(message, response, reqObj, config) {
	    _classCallCheck(this, CXPError);
	
	    var _this = _possibleConstructorReturn(this, (CXPError.__proto__ || Object.getPrototypeOf(CXPError)).call(this, message + ' ' + reqObj.url));
	
	    _this.response = response;
	    _this.request = reqObj;
	    _this.restConfig = config;
	    if (typeof Error.captureStackTrace === 'function') {
	      Error.captureStackTrace(_this, _this.constructor.name);
	    }
	    return _this;
	  }
	
	  return CXPError;
	}(Error);
	
	var getContentType = function getContentType(headers) {
	  var typeHeader = headers['content-type'];
	  return typeHeader ? typeHeader.split(';')[0] : '';
	};
	
	var parseError = function parseError(matches, response, reqObj, config) {
	  var normalizedError = matches.filter(function (_ref) {
	    var contentType = _ref.contentType,
	        search = _ref.search;
	    return contentType === getContentType(response.headers) && response.body.indexOf(search) > -1;
	  }).map(function (match) {
	    return match.callback(response.body);
	  });
	
	  if (normalizedError[0]) {
	    throw new CXPError(normalizedError, response, reqObj, config);
	  }
	};
	
	var getErrorFromUrl = function getErrorFromUrl(location) {
	  var search = 'errorMessage=';
	  var index = location.indexOf(search);
	  if (index > -1) return location.substring(index + search.length);
	  return '';
	};
	
	/**
	 * @inner
	 * @param {Adapter} adapter
	 * @param {RestConfig} config rest config
	 * @param {RequestObject} reqObj request object that initiated http request
	 * @param {Response} response
	 * @returns {Response} response object or throws CXPError
	 */
	
	exports.default = function (adapter, config, reqObj, response) {
	  adapter.log('Raw Response', response);
	
	  var statusRange = Math.floor(response.status / 100) * 100;
	  switch (statusRange) {
	    case 200:
	      parseError((0, _xx2.default)(adapter.DOMParser), response, reqObj, config);
	      if (getContentType(response.headers) === 'application/octet-stream') return reqObj.file;
	      return response;
	    case 300:
	      {
	        var message = getErrorFromUrl(response.headers.location) || response.statusText;
	        throw new CXPError('CXPRedirect: ' + message, response, reqObj, config);
	      }
	    case 500:
	      parseError((0, _xx4.default)(adapter.DOMParser), response, reqObj, config);
	      throw new CXPError(response.status + ' ' + response.statusText, response, reqObj, config);
	    default:
	      throw new CXPError(response.status + ' ' + response.statusText, response, reqObj, config);
	  }
	};
	
	/**
	 * @typedef Response
	 * @type {object}
	 * @property {number} status http status code
	 * @property {string} statusText http status text
	 * @property {object} headers http response headers
	 * @property {string} body http response body
	 */

/***/ }),
/* 9 */
/***/ (function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	exports.default = function (DOMParser) {
	  var stringToXml = function stringToXml(str) {
	    return new DOMParser().parseFromString(str, 'text/html');
	  };
	  return [{
	    contentType: 'text/html',
	    search: '<form action="/portalserver/j_spring_security_check" method="POST"',
	    callback: function callback() {
	      return 'HTML Error: Invalid Session';
	    }
	  }, {
	    contentType: 'text/html',
	    search: 'class="bd-errorMsg"',
	    callback: function callback(body) {
	      var msg = stringToXml(body).getElementsByClassName('bd-errorMsg').item(0).getElementsByTagName('p').item(1).firstChild.nodeValue;
	      return 'HTML Error: ' + msg;
	    }
	  }, {
	    contentType: 'application/xml',
	    search: '<level>ERROR</level>',
	    callback: function callback(body) {
	      var msg = stringToXml(body).getElementsByTagName('message').item(0).firstChild.nodeValue;
	      return 'HTML Error: ' + msg;
	    }
	  }];
	};

/***/ }),
/* 10 */
/***/ (function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	exports.default = function (DOMParser) {
	  var stringToXml = function stringToXml(str) {
	    return new DOMParser().parseFromString(str, 'text/html');
	  };
	  return [{
	    contentType: 'text/html',
	    search: '<title>Error 500 Server Error</title>',
	    callback: function callback(body) {
	      var doc = stringToXml(body);
	      var msg = doc.getElementsByTagName('p').item(0).childNodes[0].textContent;
	      var pre = Array.from(doc.getElementsByTagName('pre')).map(function (el) {
	        return el.textContent;
	      }).join('\n');
	      return 'Server Error: ' + msg + pre;
	    }
	  }, {
	    contentType: 'application/xml',
	    search: '<errorMessage><message>',
	    callback: function callback(body) {
	      var msg = stringToXml(body).getElementsByTagName('message').item(0).firstChild.nodeValue;
	      return 'Server Error: ' + msg;
	    }
	  }];
	};

/***/ })
/******/ ])
});
;
//# sourceMappingURL=lib-bb-portal-rest.js.map